Index: /orxonox/branches/gui/guicc/orxonox_gui.cc
===================================================================
--- /orxonox/branches/gui/guicc/orxonox_gui.cc	(revision 1997)
+++ /orxonox/branches/gui/guicc/orxonox_gui.cc	(revision 1998)
@@ -27,5 +27,5 @@
    */
   gtk_init (&argc, &argv);
-
+  gtk_rc_parse( "rc" );
 
   orxonoxGUI = new Window("Graphical Orxonox Launcher");
@@ -448,4 +448,13 @@
   gtk_label_set_line_wrap (GTK_LABEL(widget), TRUE);
 }
+
+Label:: Label (char* text)
+{
+  is_option = 0;
+  next = NULL;
+  widget = gtk_label_new (text);
+  gtk_label_set_line_wrap (GTK_LABEL(widget), TRUE);
+}
+
 Label::~Label ()
 {}
Index: /orxonox/branches/gui/guicc/orxonox_gui.h
===================================================================
--- /orxonox/branches/gui/guicc/orxonox_gui.h	(revision 1997)
+++ /orxonox/branches/gui/guicc/orxonox_gui.h	(revision 1998)
@@ -126,5 +126,4 @@
   Slider (char* slidername,int start, int end);
   ~Slider ();
-  int i;
   static gint OptionChange (GtkWidget* widget, Widget* slider);
 };
@@ -143,4 +142,5 @@
  public:
   Label ();
+  Label (char* text);
   ~Label ();
   
Index: /orxonox/branches/gui/guicc/orxonox_gui_audio.cc
===================================================================
--- /orxonox/branches/gui/guicc/orxonox_gui_audio.cc	(revision 1997)
+++ /orxonox/branches/gui/guicc/orxonox_gui_audio.cc	(revision 1998)
@@ -9,7 +9,11 @@
   enableSound->setFlagName ("no-sound", 0);
   audioBox->fill (enableSound);
+  Label* musicVolumeLabel = new Label ("Music Volume");
+  audioBox->fill (musicVolumeLabel);
   musicVolume = new Slider ("Music Volume", 0, 100);
   musicVolume->setFlagName ("music-volume", "m", 80);
   audioBox->fill (musicVolume);
+  Label* effectsVolumeLabel = new Label ("Effects Volume");
+  audioBox->fill (effectsVolumeLabel);
   effectsVolume = new Slider ("Effects Volume", 0, 100);
   effectsVolume->setFlagName ("effects-volume", "e", 80);
Index: /orxonox/branches/gui/guicc/rc
===================================================================
--- /orxonox/branches/gui/guicc/rc	(revision 1998)
+++ /orxonox/branches/gui/guicc/rc	(revision 1998)
@@ -0,0 +1,132 @@
+# pixmap_path "<dir 1>:<dir 2>:<dir 3>:..."
+#
+pixmap_path "/usr/include/X11R6/pixmaps:/home/imain/pixmaps"
+#
+# style <name> [= <name>]
+# {
+#   <option>
+# }
+#
+# widget <widget_set> style <style_name>
+# widget_class <widget_class_set> style <style_name>
+
+# Here is a list of all the possible states.  Note that some do not apply to
+# certain widgets.
+#
+# NORMAL - The normal state of a widget, without the mouse over top of
+# it, and not being pressed, etc.
+#
+# PRELIGHT - When the mouse is over top of the widget, colors defined
+# using this state will be in effect.
+#
+# ACTIVE - When the widget is pressed or clicked it will be active, and
+# the attributes assigned by this tag will be in effect.
+#
+# INSENSITIVE - When a widget is set insensitive, and cannot be
+# activated, it will take these attributes.
+#
+# SELECTED - When an object is selected, it takes these attributes.
+#
+# Given these states, we can set the attributes of the widgets in each of
+# these states using the following directives.
+#
+# fg - Sets the foreground color of a widget.
+# fg - Sets the background color of a widget.
+# bg_pixmap - Sets the background of a widget to a tiled pixmap.
+# font - Sets the font to be used with the given widget.
+#
+
+# This sets a style called "button".  The name is not really important, as
+# it is assigned to the actual widgets at the bottom of the file.
+
+style "window"
+{
+  #This sets the padding around the window to the pixmap specified.
+  #bg_pixmap[<STATE>] = "<pixmap filename>"
+  #bg_pixmap[NORMAL] = "warning.xpm"
+  bg[NORMAL] = { 0, 0, 0 }
+  fg[NORMAL] = { 1.0, 0, 0 }
+}
+
+style "scale"
+{
+  #Sets the foreground color (font color) to red when in the "NORMAL"
+  #state.
+  
+  fg[NORMAL] = { 1.0, 0, 0 }
+  bg[NORMAL] = { 1.0, 0, 0 }
+  bg[PRELIGHT] = { 1.0, 0, 0 }
+  
+  #Sets the background pixmap of this widget to that of its parent.
+  bg_pixmap[NORMAL] = "<parent>"
+}
+
+style "button"
+{
+  # This shows all the possible states for a button.  The only one that
+  # doesn't apply is the SELECTED state.
+  
+  fg[PRELIGHT] = { 0, 0, 0 }
+  bg[PRELIGHT] = { 1.0, 0, 0 }
+  bg[ACTIVE] = { 1.0, 0, 0 }
+  fg[ACTIVE] = { 0, 1.0, 0 }
+  bg[NORMAL] = { 0, 0, 0 }
+  fg[NORMAL] = { 1.0, 0, 0 }
+  bg[INSENSITIVE] = { 1.0, 1.0, 1.0 }
+  fg[INSENSITIVE] = { 1.0, 0, 1.0 }
+}
+
+# In this example, we inherit the attributes of the "button" style and then
+# override the font and background color when prelit to create a new
+# "main_button" style.
+
+style "main_button" = "button"
+{
+  font = "-adobe-helvetica-medium-r-normal--*-100-*-*-*-*-*-*"
+  bg[PRELIGHT] = { 0.75, 0, 0 }
+}
+
+style "toggle_button" = "button"
+{
+  fg[NORMAL] = { 1.0, 0, 0 }
+  fg[ACTIVE] = { 1.0, 0, 0 }
+  text[NORMAL] = { 0, 0, 0}
+  # This sets the background pixmap of the toggle_button to that of its
+  # parent widget (as defined in the application).
+  #bg_pixmap[NORMAL] = "<parent>"
+}
+
+style "text"
+{
+  #bg_pixmap[NORMAL] = "marble.xpm"
+  fg[NORMAL] = { 1.0, 0, 0 }
+}
+
+style "ruler"
+{
+  font = "-adobe-helvetica-medium-r-normal--*-20-*-*-*-*-*-*"
+}
+
+# pixmap_path "~/.pixmaps"
+
+# These set the widget types to use the styles defined above.
+# The widget types are listed in the class hierarchy, but could probably be
+# just listed in this document for the users reference.
+
+widget_class "GtkWindow" style "window"
+widget_class "GtkFrame" style "window"
+widget_class "GtkDialog" style "window"
+widget_class "GtkFileSelection" style "window"
+widget_class "*Gtk*Scale" style "scale"
+widget_class "*GtkCheckButton*" style "toggle_button"
+widget_class "*Gtk*Menu*" style "toggle_button"
+widget_class "*GtkRadioButton*" style "toggle_button"
+widget_class "*GtkButton*" style "button"
+widget_class "*Ruler" style "ruler"
+widget_class "*GtkText" style "text"
+widget_class "*GtkLabel" style "text"
+
+
+# This sets all the buttons that are children of the "main window" to
+# the main_button style.  These must be documented to be taken advantage of.
+widget "main window.*GtkButton*" style "main_button"